// 引用三方类库
//let MIAOJU_SSKJSDK = globalThis.TDAnalytics;// = require("./tdanalytics.mg.tt.min.js");
//import GravityEngine from "./gravityengine.mg.tt.min.js";
let MIAOJU_YLYQSDK;

// 全局常量
const MIAOJU_SDK_VERSION = '1.3.0';
const MIAOJU_PLATFORM_ID = 100002;
const MIAOJU_SS_SERVER_URL = "https://sskj-api.m-co.cn";

// 缓存key
const CACHE_LAUNCH_OPTIONS = "miaoju_launch_options";
const CACHE_CLIENT_ID = "miaoju_client_id";
const CACHE_USER_INFO = "miaoju_user_info";
const CACHE_ROLE_INFO = "miaoju_role_info";

// 返回值code
const RETURN_CODE_SUCCESS = 1000;
const RETURN_CODE_PARAMS_EMPTY = 1001;
const RETURN_CODE_PARAMS_ERROR = 1002;
const RETURN_CODE_LOGIN_ERROR = 1003;
const RETURN_CODE_SYSTEM_ERROR = 1004;
const RETURN_CODE_BUTTON_ERROR = 1005;
const RETURN_CODE_ROLE_ERROR = 1006;
const RETURN_CODE_CUSTOMER_ERROR = 1007;
const RETURN_CODE_PAY_ERROR = 1008;
const RETURN_CODE_USERINFO_ERROR = 1009;
const RETURN_CODE_NOT_INITED = 1010;

// 全局变量
let MIAOJU_GAME_ID = 0;
let MIAOJU_SSAPPID = "";
let MIAOJU_YLYQACCESSTOKEN = "";
let MIAOJU_GAME_VERSION = "";
let MIAOJU_USERINFO_BUTTON;
// 环境变量production为正式环境
let MIAOJU_ENV_CONFIG = "production";
let MIAOJU_SYSTEMINFO = {};
let MIAOJU_DEVICEINFO = {};
let MIAOJU_LAUNCHOPTIONS = {};
let MIAOJU_IS_INITED = false;
let MIAOJU_ONSHOW_VALUES = {};

// 全局激励视频广告对象
let MIAOJU_REWARDVIDEOAD;
let MIAOJU_REQUEST_HOST = {
    production: 'https://minigamesdk-api.miaorui1.com',
    test: 'https://pre-minigamesdk-api.miaorui1.com'
};
const IS_MOCK = false;

/**
 * 初始化
 * @params
 *  gameId SDK游戏id
 *  gameVersion 游戏版本号
 *  ssAppId 数数appid
 *  ylyqAccessToken 引力引擎access
 *  envConfig 环境变量 production/test
 * @callback 回调方法名
 */
function init(params, callback = () => {}) {
    if(IS_MOCK){
        params = {
            "gameId": 1003,
            "gameVersion": "v1.0.0", //游戏版本号
            "ssAppId": "822bb3ff1009407ebd76ed1787717c54",
            "ylyqAccessToken": "BNqc3psKs4cLxr1jW2eoAbalgtxybHrn",//"IlmBjXF4dngy7c3amghAic6utl1EbHdy",
            "envConfig": "test"
        };
    }
    consolePrintWithTime("init reciveparam:", params);
    consolePrintWithTime("init callback:", callback);

    // 判断参数是否正确
    if (!params.gameId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "gameId missing", {}));
        return false;
    }
    if (!params.gameVersion) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "gameVersion missing", {}));
        return false;
    }
    if (!params.ssAppId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "ssAppId missing", {}));
        return false;
    }
    if (!params.ylyqAccessToken) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "ylyqAccessToekn missing", {}));
        return false;
    }
    if (params.envConfig) {
        MIAOJU_ENV_CONFIG = params.envConfig;
    }
    MIAOJU_GAME_ID = params.gameId;
    MIAOJU_SSAPPID = params.ssAppId;
    MIAOJU_YLYQACCESSTOKEN = params.ylyqAccessToken;
    MIAOJU_GAME_VERSION = params.gameVersion;

    // 获取启动参数 系统函数调用
    let options = getOptions(0);
    consolePrintWithTime("init options:", options);

    // 获取系统信息
    let systemInfo = tt.getSystemInfoSync();
    //let appInfo = tt.getDeviceInfoSync();
    consolePrintWithTime("init systemInfo:", systemInfo);

    MIAOJU_SYSTEMINFO = {
        "brand": systemInfo.brand,
        "model": systemInfo.model,
        "system": systemInfo.system,
        "platform": systemInfo.platform, // ios/android/windows/mac/devtools
        "memorySize": "",
        "screenWidth": systemInfo.screenWidth,
        "screenHeight": systemInfo.screenHeight,
        "SDKVersion": systemInfo.SDKVersion,
        "language": systemInfo.language,
        "version": systemInfo.version
    }
    MIAOJU_DEVICEINFO = {
        "brand": systemInfo.brand,
        "model": systemInfo.model,
        "version": systemInfo.version,
        "system": systemInfo.system,
        "scene": options.scene,
        "sdk_version": MIAOJU_SDK_VERSION,
        "game_version": MIAOJU_GAME_VERSION
    }
    // 获得网络类型
    tt.getNetworkType({
        success(res) {
            MIAOJU_DEVICEINFO.network = res.networkType
        }
    })

    consolePrintWithTime("init deviceinfo:", MIAOJU_DEVICEINFO, MIAOJU_SYSTEMINFO);
    

    //获取客户端唯一id
    let clientId = getClientId();
    consolePrintWithTime("init clientId:", clientId);

    //数数初始化
    // TA SDK 配置对象
    var ssConfig = {
        appId: MIAOJU_SSAPPID, // 项目的 APP ID
        serverUrl: MIAOJU_SS_SERVER_URL, // 数据上报地址
        autoTrack: {
            appShow: true, // 自动采集 ta_mg_show
            appHide: true // 自动采集 ta_mg_hide
        }
    };
    consolePrintWithTime("init ssConfig:", ssConfig, globalThis.TDAnalytics);
    // 初始化
    globalThis.TDAnalytics.init(ssConfig);
    //设置数数访客id
    globalThis.TDAnalytics.setDistinctId(clientId);
    // 设置当前设备唯一识别
    ssUserSet({
        type: 1,
        properties: {
            mj_unique_ID: {
                mj_unique_ID: clientId
            }
        }
    });
    ssUserSet({
        type: 2,
        properties: {
            mj_mini_platform_id: MIAOJU_PLATFORM_ID
        }
    });

    // 请求初始化接口 /init
    apiRequest({
        url: MIAOJU_REQUEST_HOST[MIAOJU_ENV_CONFIG] + '/init',
    }).then((res) => {
        consolePrintWithTime("init apiRequest res:", res);
        if (IS_MOCK) {
            res = {
                "code": 1000,
                "message": "success",
                "data": {
                    "client_id": clientId, //设备唯一标识原样返回
                    "create_time": "2024-01-01 01:23:45" // 设备激活时间 精确到秒或毫秒
                }
            }
        }
        const {
            code,
            data
        } = res
        if (code === 1000) {
            ssUserSet({
                type: 2,
                properties: {
                    mj_device_active_time: data.create_time || getTime()
                }
            })
        }
    }, (err) => {
        consolePrintWithTime("init apiRequest err:", err);
    })

    //打开onshow的监听
    onMiniGameShow();
    consolePrintWithTime("init onMiniGameShow:");

    // 微信登录获取登录状态和信息
    login((res) => {
        consolePrintWithTime("init login res:", res);
        if (res.code == 1000) {
            // 登录成功并获取到用户信息
            const userData = res.data;
            const platformUserId = userData.platform_user_id;
            //初始化引力引擎
            const ylyqConfig = {
                accessToken: MIAOJU_YLYQACCESSTOKEN, // 项目通行证，在：网站后台-->设置-->应用列表中找到Access Token列 复制（首次使用可能需要先新增应用）
                clientId: platformUserId, // 用户唯一标识，如产品为小游戏，则必须填用户openid（注意，不是小游戏的APPID！！！）
                autoTrack: {
                    appLaunch: true, // 自动采集 $MPLaunch
                    appShow: true, // 自动采集 $MPShow
                    appHide: true, // 自动采集 $MPHide
                },
                name: "MIAOJU_YLYQSDK", // 全局变量名称, 默认为 gravityengine
                debugMode: MIAOJU_ENV_CONFIG == "production" ? "none" : "debug", // 是否开启测试模式，开启测试模式后，可以在 网站后台--设置--元数据--事件流中查看实时数据上报结果。（测试时使用，上线之后一定要关掉，改成none或者删除）
            };
            MIAOJU_YLYQSDK = new globalThis.GravityEngineAPI(ylyqConfig);
            MIAOJU_YLYQSDK.setupAndStart();
            // 请求初始化接口
            MIAOJU_YLYQSDK.initialize({
                    name: platformUserId,
                    version: 1,
                    openid: platformUserId,
                    enable_sync_attribution: false, // 是否开启同步获取归因信息，具体请参考同步归因：https://doc.gravity-engine.com/turbo-integrated/sync_attribution.html
                })
                .then((res) => {
                    consolePrintWithTime("ylyq initialize success " + res);
                })
                .catch((err) => {
                    consolePrintWithTime("ylyq initialize failed, error is " + err);
                });
            // 引力引擎打开游戏 
            ylyqReport({
                eventName: 'gravity_game_open'
            })
            // 设置用户属性
            ssUserSet({
                type: 1,
                properties: {
                    mj_last_login: userData.last_login_time
                }
            })
            if (userData.is_new == 1) {
                // 如果是新用户的话上报注册
                ssUserSet({
                    type: 2,
                    properties: {
                        mj_register_time: userData.create_time || getTime()
                    }
                })
                // 数数创建账号上报
                ssReport({
                    eventName: 'mj_creat_account'
                })
                // 引力引擎 创建账号上报
                MIAOJU_YLYQSDK.registerEvent()
            }
            // 引力引擎 登录账号上报
            MIAOJU_YLYQSDK.loginEvent()
            // 数数登录账号上报 ?? 
            ssReport({
                eventName: 'mj_login_account',
                properties: {
                    mj_login_method: '抖音小游戏'
                }
            })

            // 用户信息
            let userInfo = {
                // "nickName": userData.nick_name,
                "platformUserId": platformUserId, // 其实是open_id
                "sdkUserId": userData.user_id || 0, // sdk端的用户id
                "clientId": clientId, //访客id
                "isNew": userData.is_new // 0非新用户，1新用户
            };
            // 设置已经初始化完成了
            MIAOJU_IS_INITED = true;

            //检查来源并上报
            checkUserFrom(1);

            callback(getSuccessReturn({
                "userInfo": userInfo,
                "launchOptions": options,
                "systemInfo": MIAOJU_SYSTEMINFO
            }));
        } else {
            callback(getReturn(RETURN_CODE_LOGIN_ERROR, "init login error:" + res.message, {}));
            return false;
        }
    });
    /*
    callback(getSuccessReturn({
        "userInfo": "",
        "launchOptions": "",
        "systemInfo": ""
    }));*/
}

/**
 * 登录
 * @callback 回调方法名
 */
function login(loginCallback) {
    // 先使用sdk登录态登录，如果失败则重新获取微信code登录
    // 如果没有token直接去获取code
    const user_info = tt.getStorageSync(CACHE_USER_INFO)
    const token = user_info.token || ''
    consolePrintWithTime("token缓存：", token);

    if (!token) {
        // 没有token 去wx.login获取code
        userLoginWithTt(loginCallback,"tokenEmpty");
    } else {
        // 有token 先检测下微信session_key有没有过期，过期则还是要调code登录，否则用token去请求
        tt.checkSession({
          success () {
            //session_key 未过期，并且在本生命周期一直有效
            userLogin({
                token: token
            }, loginCallback)
          },
          fail () {
            // session_key 已经失效，需要重新执行登录流程
            userLoginWithTt(loginCallback,"checkSessionFail");
          }
        })
        
    }
}

//微信code登录
function userLoginWithTt(loginCallback,fromStr=''){
  wxPromisify(tt.login)({
    timeout: 10000,
  }).then(
    (res) => {
        const {
            code
        } = res
        if (code) {
            consolePrintWithTime("[userLoginWithTt]"+fromStr+" 这里获取到code:", code);
            // 获取到code 去请求用户登录接口
            userLogin({
                code: code
            }, loginCallback)
        } else {
            console.error("[userLoginWithTt]"+fromStr+' tt.login获取code失败')
            loginCallback({
                "code": RETURN_CODE_LOGIN_ERROR,
                "message": 'tt.login获取code失败'
            });
        }
    },
    (err) => {
        console.error("[userLoginWithTt]"+fromStr+' tt.login报错', err)
        loginCallback({
            "code": RETURN_CODE_LOGIN_ERROR,
            "message": err.errMsg || 'tt.login error'
        })
    })
}

/**
 * 请求登录接口
 */
function userLogin(params, loginCallback) {
    apiRequest({
        url: MIAOJU_REQUEST_HOST[MIAOJU_ENV_CONFIG] + '/user/login',
        data: params
    }).then(
        (result) => {
            if (IS_MOCK) {
                result = {
                    "code": 1000,
                    "message": "success",
                    "data": {
                        "user_id": 10000001, //SDK用户ID
                        "platform_user_id": "xmtest20241105", //即微信open_id
                        "platform_id": 100002, //平台ID
                        "game_id": 1002, //游戏ID
                        "token": "lwoonwmyyyabltlwylvs", //登录态
                        "nick_name": "抖音用户", //昵称
                        "gender": "男", //性别：男、女、未知
                        "avatar_url": "https://****", //头像
                        "union_id": "oonwmyyyabltsraslwylvs", //即微信open_id
                        "channl_id": 10000001, //渠道来源
                        "is_new": 1, // 0非新用户，1新用户
                        "create_time": "2018-01-01 01:23:45", // 注册时间
                        "last_login_time": "2018-01-01 01:23:45", // 最后登录时间
                        "total_login_num": 10, // 累计登录次数
                        "active_days": 8, // 累计活跃天数
                    }
                }
            }
            const {
                code,
                message,
                data
            } = result;
            if (code === 1000) {
                // 登录成功 添加用户信息缓存
                tt.setStorageSync(CACHE_USER_INFO, data);
                // 执行登录回调 loginCallback
                loginCallback(result);
            } else if (code === 1001) {
                // token 登录态无效或已过期 清除用户信息（登录态）
                tt.removeStorageSync(CACHE_USER_INFO);
                // 如果是根据token去请求用户登录接口的，则有token失效的风险，所以这个接口会有token失效的概率，如果返回此错误码，且请求参数token不为空，则重试 则重新使用微信登录获取到的code 去请求登录接口
                if (params.token) {
                  userLoginWithTt(loginCallback,"tokenLoginFail");

                } else {
                    loginCallback({
                        "code": code,
                        "message": message
                    });
                }
            } else {
                loginCallback({
                    "code": code,
                    "message": message
                });
            }
    }, (err) => {
        loginCallback({
            "code": RETURN_CODE_LOGIN_ERROR,
            "message": '请求 /login接口错误'
        });
    })
}

/**
 * 支付
 * @param {*} params 
 * @param {*} callback 
 * @returns 
 */
function pay(params, callback = () => {}) {
    const funcNameMsg = "pay";
    if (!isInited()) {
        // 未初始化
        callback({
            "code": RETURN_CODE_NOT_INITED,
            "message": funcNameMsg+'未完成初始化',
            "data": {}
        });
        return false;
    }
    consolePrintWithTime(funcNameMsg+" reciveparam:", params,callback);
    if(IS_MOCK){
        params = {
            "productId": "mj_unity_sdk_test", //商品ID
            "gameOrderId": "10000123456", //游戏订单ID
            "customData": "", //自定义参数
            "productName": "MJSDK道具", //商品名称
            "serverId": "1", //服ID
            "serverName": "1服", //服名称
            "roleId": "666666", //角色ID
            "roleName": "66666角色", //角色名
            "roleLevel": "8", //角色等级
            "buyQuantity": 1, //购买数量
            "goodsPrice": 100, //单价分 1元=100分
            "payNoticeUrl": "", //支付回调服务端地址
            //"conversationParams": {
            //    "showMessageCard": true,
            //    "sendMessageTitle": "我是一个充值小程序O O"
            //} // 要传的客服会话参数
        };
    }
    
    // 判断参数是否正确
    if (!params.gameOrderId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "gameOrderId missing", {}));
        return false;
    }
    if (!params.productId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "productId missing", {}));
        return false;
    }
    if (!params.serverId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "serverId missing", {}));
        return false;
    }
    if (!params.serverName) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "serverName missing", {}));
        return false;
    }
    if (!params.roleId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "roleId missing", {}));
        return false;
    }
    if (!params.roleName) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "roleName missing", {}));
        return false;
    }
    if (!params.productName) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "productName missing", {}));
        return false;
    }
    if (!params.buyQuantity) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "buyQuantity missing", {}));
        return false;
    }
    if (!params.goodsPrice) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "goodsPrice missing", {}));
        return false;
    }
    const pay_params = {
        game_order_id: params.gameOrderId,
        product_id: params.productId,
        product_name: params.productName,
        buy_quantity: params.buyQuantity,
        goods_price: params.goodsPrice,
        pay_notify_url: params.payNoticeUrl || '',
        custom_data: params.customData || '',
    }
    // 请求创单接口创建订单和米大师支付参数
    apiRequest({
        url: MIAOJU_REQUEST_HOST[MIAOJU_ENV_CONFIG] + '/order/create',
        data: pay_params
    }).then((result) => {
        if (IS_MOCK) {
            result = {
                "code": 1000,
                "message": "success",
                "data": {
                    "order_id": "8866202408031533560002", //订单唯一编号
                    "sign_data": '{"mode":"goods","offerId":"123","buyQuantity":1,"env":0,"currencyType":"CNY","platform":"android","zoneId":"1","productId":"testproductId","goodsPrice":10,"outTradeNo":"xxxxxx","attach":"testdata"}', //本次返回的为字符串类型的JSON格式
                    "pay_sign": "d0b8bbccbe34ed11549bcfd6602b08711f4acc0965253a949cd6a2b895152f9d", //支付签名
                    "signature": "d0b8bbccbe34ed11549bcfd6602b08711f4acc0965253a949cd6a2b895152f9d", //用户态签名
                }
            }
        }
        const {
            code,
            data,
            message
        } = result;
        consolePrintWithTime("requestGamePayment sdkapi res:", result);
        if (code == 1000 || code == 3004) {
            // 引力引擎上报 创单
            ylyqReport({
                eventName: 'gravity_app_order',
                properties: {
                    pay_reason: params.productName,
                    pay_amount: params.goodsPrice * params.buyQuantity,//人民币。单位分
                    order_id: data.order_id || ''
                }
            })
            // 数数上报 创单
            ssReport({
                eventName: 'mj_order_init',
                properties: {
                    mj_product_id: params.productId,
                    mj_order_id: data.order_id || '',
                    mj_num: params.goodsPrice * params.buyQuantity/100,//人民币。单位元
                    mj_order_time: getTime(),
                }
            })
        }
        if (code === 1000) {
            // 安卓支付
            tt.requestGamePayment({
                mode: "game",
                env: 0, //支付环境
                currencyType: "CNY", // 币种：目前仅为 "CNY"
                platform: "android", // 申请接入时的平台：目前仅为"android"
                buyQuantity: data.total_pay, // 购买金币数，如果是1:10则他等于10*人民币元，如果1:1则等于人民币元
                zoneId: "1",
                customId: data.order_id,
                extraInfo: data.extra_info,
                success: function (res) {
                    consolePrintWithTime("requestGamePayment success res:", res);
                    // 支付成功
                    callback(getSuccessReturn({"sdkOrderId": order_id || ''}));
                },
                fail: function (res) {
                    // 失败
                    consolePrintWithTime("requestGamePayment error res:", res);
                    callback(getReturn(RETURN_CODE_PAY_ERROR, funcNameMsg+" requestGamePayment fail", res));
                },
                complete: function (res) {
                    consolePrintWithTime("requestGamePayment complete res:", res);
                }
            });
        } else if (code === 3004) {
            //iOS支付
            tt.openAwemeCustomerService({
                currencyType: "DIAMOND", // 币种：目前仅为"DIAMOND"
                buyQuantity: data.total_pay, // 购买金币数，如果是1:10则他等于10*人民币元，如果1:1则等于人民币元
                zoneId: "1",
                customId: data.order_id, //开发者自定义唯一订单号。如不填，支付结果回调将不包含此字段，将导致游戏开发者无法发放游戏道具, 基础库版本低于1.55.0没有此字段
                extraInfo: data.extra_info,  //extraInfo要转成字符串
                success(res) {
                    consolePrintWithTime("openAwemeCustomerService success res:", res);
                    // 支付成功
                    callback(getSuccessReturn({"sdkOrderId": order_id || ''}));
                },
                fail(res) {
                    consolePrintWithTime("openAwemeCustomerService error res:", res);
                    callback(getReturn(RETURN_CODE_PAY_ERROR, funcNameMsg+" requestGamePayment fail", res));
                },
                complete(res) {
                    consolePrintWithTime("openAwemeCustomerService complete res:", res);
                },
            }); 
        } else {
            callback(getReturn(RETURN_CODE_PAY_ERROR, funcNameMsg+" order/create 接口创单失败 "+message, {}));
        }
    }, (err) => {
        callback(getReturn(RETURN_CODE_PAY_ERROR, funcNameMsg+" order/create 接口失败 "+ (err.errMsg || ''), {}));
    })
}

/**
 * 初始化并展示激励视频广告
 * @params 
 *  adUnitId 广告id
 * @callback 回调方法名
 */
function rewardVideoAdCreate(params, callback = () => {}) {
    const funcNameMsg = "rewardVideoAdCreate";
    if (!isInited()) {
        // 未初始化
        callback({
            "code": RETURN_CODE_NOT_INITED,
            "message": funcNameMsg+'未完成初始化',
            "data": {}
        });
        return false;
    }
    if(IS_MOCK){
        params = {
            "adUnitId":"16efnm09m71d3p97jb"
        }
    }
    
    consolePrintWithTime(funcNameMsg+" reciveparam", params,callback);

    if (!params.adUnitId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, funcNameMsg+" adUnitId missing", {}));
        return false;
    }
    // 用户打开广告
    ssReport({
        eventName: 'mj_ad_init'
    })

    // 创建激励视频广告实例，提前初始化
    MIAOJU_REWARDVIDEOAD = tt.createRewardedVideoAd({
        adUnitId: params.adUnitId
    })

    // 广告加载
    MIAOJU_REWARDVIDEOAD.onLoad(() => {
        consolePrintWithTime(funcNameMsg+" onLoad:ok");
    })

    // 用户触发广告后，显示激励视频广告
    MIAOJU_REWARDVIDEOAD.load()
        .then(() => {
            MIAOJU_REWARDVIDEOAD.show()
                .then(() => {
                    MIAOJU_YLYQSDK.adShowEvent("reward", params.adUnitId, params.otherProperties || {});
                })
                .catch((err1) => {
                    consolePrintWithTime(funcNameMsg+" err1", err1);
                    // 失败重试
                    MIAOJU_REWARDVIDEOAD.load()
                        .then(() => {
                            MIAOJU_REWARDVIDEOAD.show().then(() => {
                                MIAOJU_YLYQSDK.adShowEvent("reward", params.adUnitId, params.otherProperties || {});
                            })
                        })
                        .catch(err2 => {
                            callback(getReturn(RETURN_CODE_PARAMS_ERROR, funcNameMsg+" error", err2));
                            return false;
                        })
                })
        })

    MIAOJU_REWARDVIDEOAD.onError(err => {
        consolePrintWithTime(funcNameMsg+" onError:", err);
        MIAOJU_REWARDVIDEOAD.destroy();
        callback(getReturn(RETURN_CODE_SYSTEM_ERROR, funcNameMsg+" onError", err));
        return false;
    });

    // 监听用户关闭广告
    MIAOJU_REWARDVIDEOAD.onClose(res => {
        consolePrintWithTime(funcNameMsg+" onClose:", res);
        // 用户点击了【关闭广告】按钮
        if (res && res.isEnded) {
            // 正常播放结束，可以下发游戏奖励 
            // 用户看完广告
            ssReport({
                eventName: 'mj_ad_finish_done'
            })
            ylyqReport({
                eventName: 'gravity_ad_view'
            })
            consolePrintWithTime(funcNameMsg+" onClose:ok");
            MIAOJU_REWARDVIDEOAD.destroy();
            callback(getSuccessReturn({}));
            return true;
        } else {
            // 播放中途退出，不下发游戏奖励
            // 用户中途关闭广告（时长未达获奖条件）
            ssReport({
                eventName: 'mj_ad_finish_quit'
            })
            consolePrintWithTime(funcNameMsg+" onClose:break");
            MIAOJU_REWARDVIDEOAD.destroy();
            callback(getReturn(RETURN_CODE_SYSTEM_ERROR, funcNameMsg+" onClose no finish", res));
            return false;
        }
    });
}

/**
 * 上报数数 自定义事件
 * @param {*} params 
 * @param {*} callback 
 */
function ssReport(params, callback = () => {}) {
    consolePrintWithTime("ssReport reciveparam", params);
    consolePrintWithTime("ssReport callback", callback);
    // params = {
    //     eventName: '',
    //     properties: {}
    // }

    // 判断参数是否正确
    if (!params.eventName) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "eventName missing", {}));
        return false;
    }
    // 发送事件
    globalThis.TDAnalytics.track({
        eventName: params.eventName, //追踪事件的名称
        properties: params.properties || {}, //需要上传的事件属性
    });
    callback({
        code: RETURN_CODE_SUCCESS,
        message: "ssReport成功",
        data: {}
    });
}

/**
 * 上报数数 设置用户属性
 * @param {*} params  type 设置用户属性的类型 1 user_set 2 userSetOnce 3 userAdd 
 * @param {*} callback 
 */
function ssUserSet(params, callback = () => {}) {
    consolePrintWithTime("ssUserSet reciveparam", params);
    consolePrintWithTime("ssUserSet callback", callback);
    // params = {
    //     type: 1, // 设置用户属性的类型 1 user_set 2 userSetOnce 3 userAdd 
    //     properties: {}
    // }
    if (!params.type) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "type missing", {}));
        return false;
    }
    if (!params.properties) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "properties missing", {}));
        return false;
    }
    if (Object.keys(params.properties).length == 0) {
        // 说明params.properties为空
        callback(getReturn(RETURN_CODE_PARAMS_ERROR, "properties error", {}));
        return false;
    }

    if (params.type == 1) {
        // 设置用户属性
        globalThis.TDAnalytics.userSet({
            properties: params.properties //事件属性
        })
    } else if (params.type == 2) {
        // 用户属性只要设置一次
        globalThis.TDAnalytics.userSetOnce({
            properties: params.properties //事件属性
        })
    } else if (params.type == 3) {
        // 用户属性累加
        globalThis.TDAnalytics.userAdd({
            properties: params.properties //事件属性
        })
    }
    callback({
        code: RETURN_CODE_SUCCESS,
        message: "ssUserSet成功",
        data: {}
    });
}

/**
 * 上报引力引擎 自定义事件
 * @param {*} params 
 * @param {*} callback 
 */
function ylyqReport(params, callback = () => {}) {
    consolePrintWithTime("ylyqReport reciveparam", params);
    consolePrintWithTime("ylyqReport callback", callback);
    // params = {
    //     eventName: '',
    //     properties: {}
    // }
    if (!params.eventName) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "eventName missing", {}));
        return false;
    }

    MIAOJU_YLYQSDK.track(
        params.eventName, //追踪事件的名称
        params.properties || {}, //需要上传的事件属性
    );
    callback({
        code: RETURN_CODE_SUCCESS,
        message: "ylyqReport成功",
        data: {}
    });
}

/**
 * 获取系统参数及启动参数
 */
function getUserLaunchInfo() {
    const funcNameMsg = "getUserLaunchInfo";
    if (!isInited()) {
        // 未初始化
        return {
            "code": RETURN_CODE_NOT_INITED,
            "message": funcNameMsg+' 未完成初始化',
            "data": {}
        };
    }
    const options = getOptions(0)
    return {
        code: RETURN_CODE_SUCCESS,
        message: "getUserLaunchInfo成功",
        data: {
            "launchOptions": options,
            "systemInfo": MIAOJU_SYSTEMINFO
        }
    }
}

/**
 * 打开客服
 * @param {*} params 
 * @param {*} callback 
 */
function openCustomerService(params, callback = () => {}) {
    if (!isInited()) {
        // 未初始化
        callback({
            "code": RETURN_CODE_NOT_INITED,
            "message": 'openCustomerService未完成初始化',
            "data": {}
        });
        return false;
    }
    consolePrintWithTime("openCustomerService reciveparam", params,callback);
    if (!params.type) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "openCustomerService type missing", {}));
        return false;
    }

    /*
    params = {
         "type": 2,
         "sessionFrom": ""    
    }*/
    tt.openCustomerServiceConversation({
        type:params.type,
        sessionFrom:params.sessionFrom,
        success:(res) => {
            consolePrintWithTime("openCustomerServiceConversation res", res);
            callback({
                code: RETURN_CODE_SUCCESS,
                message: "openCustomerService成功",
                data: {}
            });
        }, 
        fail:(err) => {
            consolePrintWithTime("openCustomerServiceConversation err", err);
            callback(getReturn(RETURN_CODE_CUSTOMER_ERROR, "openCustomerService error", {}));
        }
    })
}

/**
 * 获取用户信息
 * @param {*} params 
 * @param {*} callback 
 */
function getUserInfo(params, callback = () => {}) {
    const funcNameMsg = "getUserInfo";
    if (!isInited()) {
      // 未初始化
      callback({
        "code": RETURN_CODE_NOT_INITED,
        "message": funcNameMsg+'未完成初始化',
        "data": {}
      });
    }
    consolePrintWithTime(funcNameMsg+" reciveparam", params,callback);
  
    const user_params = {
      "UserInfo": {},
      "rawData": "",
      "signature": "",
      "encryptedData": "",
      "iv": "",
      "realNameAuthenticationStatus":""
    }
    // 获取用户信息
    tt.getUserInfo({
        withCredentials: true,
        withRealNameAuthenticationInfo: true,
        success(res) {
            consolePrintWithTime(funcNameMsg+" success", res);
            // 成功获取用户信息 
            user_params.encryptedData = res.encryptedData;
            user_params.rawData = res.rawData;
            user_params.signature = res.signature;
            user_params.iv = res.iv;
            user_params.UserInfo = res.UserInfo;
            user_params.realNameAuthenticationStatus = res.realNameAuthenticationStatus;
            reqUserInfo({
                user_info: JSON.stringify(user_params)
            }, callback);
        },
        fail(res) {
            consolePrintWithTime(funcNameMsg+" fail", res);
            reqUserInfo({}, callback);
        },
    });
}

/**
 * 请求用户信息接口
 */
function reqUserInfo(params, callback) {
    apiRequest({
        url: MIAOJU_REQUEST_HOST[MIAOJU_ENV_CONFIG] + '/user/info',
        data: params
    }).then(
        (result) => {
            if (IS_MOCK) {
                result = {
                    "code": 1000,
                    "message": "success",
                    "data": {
                        "user_id": 10000001, //SDK用户ID
                        "platform_user_id": "lwoonwmyyyabltlwylvs", //即微信open_id
                        "platform_id": 100001, //平台ID
                        "game_id": 1001, //游戏ID
                        "token": "lwoonwmyyyabltlwylvs", //登录态
                        "nick_name": "张胖", //昵称
                        "gender": "男", //性别：男、女、未知
                        "avatar_url": "https://****", //头像
                        "union_id": "oonwmyyyabltsraslwylvs", //即微信open_id
                        "channl_id": 10000001, //渠道来源
                    }
                }
            }
            const {
                code,
                message,
                data
            } = result
            consolePrintWithTime("reqUserInfo res", code,message,data);
            if (code === 1000) {
                // 保存用户信息缓存
                tt.setStorageSync(CACHE_USER_INFO, data)
                let scopeUserInfo = true
                if(params.user_info === ""){
                  scopeUserInfo = false
                }
                callback({
                    "code": code,
                    "message": message,
                    "data": {
                        "nickName": data.nick_name || '',
                        "avatarUrl": data.avatar_url || '',
                        "unionId": data.union_id || '',
                        "createTime": data.create_time || '',
                        "gender": data.gender || '',
                        "platformUserId": data.platform_user_id || '',
                        "sdkUserId": data.user_id || 0,
                        "scopeUserInfo":scopeUserInfo
                    }
                })
            } else {
                callback({
                    "code": RETURN_CODE_USERINFO_ERROR,
                    "message": message,
                    "data": {}
                })
            }
        },
        (err) => {
          consolePrintWithTime("reqUserInfo err", err);
          callback({
              "code": RETURN_CODE_USERINFO_ERROR,
              "message": '请求 /user/info接口错误'
          })
        })
}

/**
 * 创建角色  account_id : 服id_角色id
 * @param {*} params 
 * @param {*} callback 
 */
function createRole(params, callback = () => {}) {
    const funcNameMsg = "createRole";
    if (!isInited()) {
      // 未初始化
      callback({
        "code": RETURN_CODE_NOT_INITED,
        "message": funcNameMsg+'未完成初始化',
        "data": {}
      });
    }
    consolePrintWithTime(funcNameMsg+" reciveparam", params,callback);

    if(IS_MOCK){
        params = {
            "serverId": "1", //服ID
            "serverName": "1服", //服名称
            "roleId": "66666", //角色ID
            "roleName": "角色66666", //角色名
            "roleLevel": "11", //角色等级
            "roleCreateTime": 1730890543, //角色创建时间戳，秒
            "location": "浙江1" //大区
         }
    }
    
    // 判断参数是否正确
    if (!params.serverId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "serverId missing", {}));
        return false;
    }
    if (!params.serverName) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "serverName missing", {}));
        return false;
    }
    if (!params.roleId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "roleId missing", {}));
        return false;
    }
    if (!params.roleName) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "roleName missing", {}));
        return false;
    }
    if (!params.roleLevel) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "roleLevel missing", {}));
        return false;
    }
    if (!params.location) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "location missing", {}));
        return false;
    }
    const req_params = {
        "role_id": params.roleId,
        "role_name": params.roleName,
        "role_level": params.roleLevel,
        "server_id": params.serverId,
        "server_name": params.serverName,
        "location": params.location
    }

    apiRequest({
        url: MIAOJU_REQUEST_HOST[MIAOJU_ENV_CONFIG] + '/user/role',
        data: {
            type: 0, // 不传或0 默认创角  1表示登录角色 
            role_info: JSON.stringify(req_params) // 游戏传过来的参数转化为json字符串格式
        }
    }).then((result) => {
        if (IS_MOCK) {
            result = {
                "code": 1000,
                "message": "createRole success",
                "data": {
                    "user_id": 10000001, //SDK用户ID
                    "platform_user_id": "lwoonwmyyyabltlwylvs", //即微信open_id
                    "platform_id": 100001, //平台ID
                    "game_id": 1001, //游戏ID
                    "token": "lwoonwmyyyabltlwylvs", //登录态
                    "nick_name": "张胖", //昵称
                    "gender": "男", //性别：男、女、未知
                    "avatar_url": "https://****", //头像
                    "union_id": "oonwmyyyabltsraslwylvs", //即微信open_id
                    "channl_id": 10000001, //渠道来源
                    "role_create_time": "2018-01-01 01:23:45" // 角色创建时间
                }
            }
        }
        const {
            code,
            data
        } = result
        if (code === 1000) {
            // 缓存创角信息
            tt.setStorageSync(CACHE_ROLE_INFO, req_params);
            // 设置数数账号ID account_id : 服id_角色id
            globalThis.TDAnalytics.login(getAccountID(params))
            const options = getOptions(0)
            let channel_id = 0
            if (Object.keys(options.query).length !== 0) {
                channel_id = options.query.channel_id || 0
            }
            const user_info = tt.getStorageSync(CACHE_USER_INFO)
            // 只设置一次的属性
            ssUserSet({
                type: 2,
                properties: {
                    mj_role_create_time: data.role_create_time || getTime(),
                    mj_role_id: params.roleId,
                    mj_passport: user_info.user_id || '',
                    mj_wx_openid: user_info.platform_user_id || '',
                    mj_rolename: params.roleName,
                    mj_server_id: params.serverId,
                    mj_location: params.location,
                    mj_channel_id: channel_id,
                    mj_version_game: MIAOJU_GAME_VERSION,
                    mj_version_sdk: MIAOJU_SDK_VERSION
                }
            })
            // 设置用户属性
            ssUserSet({
                type: 1,
                properties: {
                    mj_role_name: params.roleName
                }
            })
            // 玩家创建角色时上报
            ssReport({
                eventName: 'mj_create_role'
            })
            // 创角 引力引擎上报
            ylyqReport({
                eventName: 'gravity_create_role'
            })
            // 执行回调 callback
            callback(result);
        } else {
            callback(getReturn(RETURN_CODE_ROLE_ERROR, "createRole error", {}))
        }
    }, (err) => {
        callback(getReturn(RETURN_CODE_ROLE_ERROR, "请求 /user/role 接口错误", {}))
    })
}

/**
 * 登录角色  account_id : 服id_角色id
 * @param {*} params 
 * @param {*} callback 
 */
function loginRole(params, callback = () => {}) {
    const funcNameMsg = "loginRole";
    if (!isInited()) {
      // 未初始化
      callback({
        "code": RETURN_CODE_NOT_INITED,
        "message": funcNameMsg+'未完成初始化',
        "data": {}
      });
    }
    consolePrintWithTime(funcNameMsg+" reciveparam", params,callback);

    if(IS_MOCK){
        params = {
            "serverId": "1", //服ID
            "serverName": "1服", //服名称
            "roleId": "66666", //角色ID
            "roleName": "角色66666", //角色名
            "roleLevel": "11", //角色等级
            "roleCreateTime": 1730890543, //角色创建时间戳，秒
            "location": "浙江1" //大区
         }
    }
    // 判断参数是否正确
    if (!params.serverId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "serverId missing", {}));
        return false;
    }
    if (!params.serverName) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "serverName missing", {}));
        return false;
    }
    if (!params.roleId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "roleId missing", {}));
        return false;
    }
    if (!params.roleName) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "roleName missing", {}));
        return false;
    }
    if (!params.roleLevel) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "roleLevel missing", {}));
        return false;
    }
    if (!params.location) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "location missing", {}));
        return false;
    }
    const req_params = {
        "role_id": params.roleId,
        "role_name": params.roleName,
        "role_level": params.roleLevel,
        "server_id": params.serverId,
        "server_name": params.serverName,
        "location": params.location
    }
    apiRequest({
        url: MIAOJU_REQUEST_HOST[MIAOJU_ENV_CONFIG] + '/user/role',
        data: {
            type: 1, // 不传或0 默认创角  1表示登录角色 
            role_info: JSON.stringify(req_params) // 游戏传过来的参数转化为json字符串格式
        }
    }).then((result) => {
        if (IS_MOCK) {
            result = {
                "code": 1000,
                "message": "loginRole success",
                "data": {
                    "user_id": 10000001, //SDK用户ID
                    "platform_user_id": "lwoonwmyyyabltlwylvs", //即微信open_id
                    "is_new": 1, //是否新用户,新用户则需要调用注册reg接口
                    "nickname": "测试昵称",
                    "avatar": "http://*****",
                    "unionid": "123456",
                    "token": "abcdefg"
                }
            }
        }
        const {
            code,
            data
        } = result
        if (code === 1000) {
            // 缓存登录角色的信息
            tt.setStorageSync(CACHE_ROLE_INFO, req_params);
            // 设置数数账号ID
            globalThis.TDAnalytics.login(getAccountID(params))
            // 玩家登录角色时上报
            ssReport({
                eventName: 'mj_login_role'
            })
            // 执行回调 callback
            callback(getSuccessReturn(data));
        } else {
            callback(getReturn(RETURN_CODE_ROLE_ERROR, "loginRole error", {}))
        }
    }, (err) => {
        callback(getReturn(RETURN_CODE_ROLE_ERROR, "请求 /user/role 接口错误", {}))
    })
}

/**
 * 切换角色 
 * @param {*} params 
 * @param {*} callback 
 */
function changeRole(params, callback = () => {}) {
    const funcNameMsg = "changeRole";
    if (!isInited()) {
      // 未初始化
      callback({
        "code": RETURN_CODE_NOT_INITED,
        "message": funcNameMsg+'未完成初始化',
        "data": {}
      });
    }
    consolePrintWithTime(funcNameMsg+" reciveparam", params,callback);

    if(IS_MOCK){
        params = {
            "serverId": "1", //服ID
            "serverName": "1服", //服名称
            "roleId": "66666", //角色ID
            "roleName": "角色66666", //角色名
            "roleLevel": "11", //角色等级
            "roleCreateTime": 1730890543, //角色创建时间戳，秒
            "location": "浙江1" //大区
         }
    }
    // 判断参数是否正确
    if (!params.serverId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "serverId missing", {}));
        return false;
    }
    if (!params.serverName) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "serverName missing", {}));
        return false;
    }
    if (!params.roleId) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "roleId missing", {}));
        return false;
    }
    if (!params.roleName) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "roleName missing", {}));
        return false;
    }
    if (!params.roleLevel) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "roleLevel missing", {}));
        return false;
    }
    if (!params.location) {
        callback(getReturn(RETURN_CODE_PARAMS_EMPTY, "location missing", {}));
        return false;
    }
    // 玩家切换角色时上报数数
    ssReport({
        eventName: 'mj_change_role'
    })
    callback({
        "code": RETURN_CODE_SUCCESS,
        "message": "changeRole success",
        "data": {}
    });
    return false;
}


/**
 * 监听小游戏回到前台的事件
 * @param {*} params 
 * @param {*} callback 
 */
function onMiniGameShow(params, callback = () => {}) {
    const funcNameMsg = "onMiniGameShow";
    consolePrintWithTime(funcNameMsg+" reciveparam", params,callback);

    tt.onShow((res)=>{
        consolePrintWithTime("init onShow res:", res);
        //从侧边栏来：scene值为021036，launch_from为homepage，location为sidebar_card
        MIAOJU_ONSHOW_VALUES = res;
        //检查来源并上报
        checkUserFrom(2);
        callback(getSuccessReturn(res));
    });
}

/**
 * 判定是否来自侧边栏
 * @param {*} params 
 * @param {*} callback 
 */
function isFromSidebar(params, callback = () => {}) {
    const funcNameMsg = "isFromSidebar";
    if (!isInited()) {
        // 未初始化
        callback({
            "code": RETURN_CODE_NOT_INITED,
            "message": funcNameMsg+'未完成初始化',
            "data": {}
        });
        return false;
    }
    consolePrintWithTime(funcNameMsg+" reciveparam", params,callback);
    //检查侧边栏是否可用
    tt.checkScene({
        scene: "sidebar",
        success: (res) => {
            consolePrintWithTime("check scene success: ", res);
            let showobj = {"show":"2"};
            //成功回调逻辑
            if(!res.isExist){
                callback(getSuccessReturn(showobj));
                return false;
            }
            consolePrintWithTime("check scene MIAOJU_ONSHOW_VALUES: ", MIAOJU_ONSHOW_VALUES);
            if ('scene' in MIAOJU_ONSHOW_VALUES) {
                //如果onshow监听已经获取到了场景值了
                //从侧边栏来：scene值为021036，launch_from为homepage，location为sidebar_card
                if(MIAOJU_ONSHOW_VALUES.scene == "021036" && MIAOJU_ONSHOW_VALUES.launch_from=="homepage" && MIAOJU_ONSHOW_VALUES.location=="sidebar_card"){
                    showobj.show = "1";
                }
            }else{
                //如果onshow监听没有获取到了场景值，则用启动参数的scene
                let options = getOptions(1);
                if(options.scene == "021036"){
                    showobj.show = "1";
                }
            }
            callback(getSuccessReturn(showobj));
        },
        fail: (res) => {
            consolePrintWithTime("check scene fail:", res);
            //失败回调逻辑
            callback(getReturn(RETURN_CODE_SYSTEM_ERROR, "check scene fail:"+res.errMsg, res));
        }
    });
}

/**
 * 跳转侧边栏
 * @param {*} params 
 * @param {*} callback 
 */
function navigateToScene(params, callback = () => {}) {
    const funcNameMsg = "navigateToScene";
    if (!isInited()) {
        // 未初始化
        callback({
            "code": RETURN_CODE_NOT_INITED,
            "message": funcNameMsg+'未完成初始化',
            "data": {}
        });
        return false;
    }
    consolePrintWithTime(funcNameMsg+" reciveparam", params,callback);

    tt.navigateToScene({
        scene: "sidebar",
        success: (res) => {
            consolePrintWithTime(funcNameMsg+" success");
            // 跳转成功回调逻辑
            callback(getSuccessReturn({}));
        },
        fail: (res) => {
            consolePrintWithTime(funcNameMsg+" fail: ", res);
            // 跳转失败回调逻辑
            callback(getReturn(RETURN_CODE_SYSTEM_ERROR, funcNameMsg+" fail: "+res.errMsg, res));
        },
    });
}

/**
 * 敏感词监听，监听键盘输入、确认、键盘收起
 * @param {*} params 
 * @param {*} callback 
 */
function onKeyboardAction(params, callback = () => {}) {
    const funcNameMsg = "onKeyboardAction";
    if (!isInited()) {
        // 未初始化
        callback({
            "code": RETURN_CODE_NOT_INITED,
            "message": funcNameMsg+'未完成初始化',
            "data": {}
        });
        return false;
    }
    consolePrintWithTime(funcNameMsg+" reciveparam", params,callback);

    //监听键盘输入事件，用于敏感词判定
    tt.onKeyboardInput(data => {
        consolePrintWithTime('onKeyboardInput:', data);
        callback(getSuccessReturn(data));
    });
    //监听用户点击键盘确定按钮时的事件
    tt.onKeyboardConfirm((data) => {
        consolePrintWithTime('onKeyboardConfirm:', data);
        callback(getSuccessReturn(data));
    });
    //监听键盘收起的事件
    tt.onKeyboardComplete((data) => {
        consolePrintWithTime('onKeyboardComplete:', data);
        callback(getSuccessReturn(data));
    });
}

function addShortcut(params, callback = () => {}) {
    const funcNameMsg = "addShortcut";
    if (!isInited()) {
        // 未初始化
        callback({
            "code": RETURN_CODE_NOT_INITED,
            "message": funcNameMsg+'未完成初始化',
            "data": {}
        });
        return false;
    }
    consolePrintWithTime(funcNameMsg+" reciveparam", params,callback);

    //添加到桌面快捷方式
    tt.addShortcut({
        success(res) {
            consolePrintWithTime(funcNameMsg+" suc:",res);
            // 上报
            ssReport({
                eventName: 'mj_add_desk'
            })
            callback(getSuccessReturn({}));
        },
        fail(err) {
            consolePrintWithTime(funcNameMsg+" fail", err);
            callback(getReturn(RETURN_CODE_SYSTEM_ERROR, funcNameMsg+" fail: "+res.errMsg, res));
        }
    });

}

/**
 * 检查是否来源于某个场景
 * @param {*} funcType 2初始化，1onshow监听
 */
function checkUserFrom(funcType){
    consolePrintWithTime('checkUserFrom funcType:', funcType);
    let ssEventName = '';
    if(funcType == 2){
        consolePrintWithTime('checkUserFrom 1:', MIAOJU_ONSHOW_VALUES);
        if ('scene' in MIAOJU_ONSHOW_VALUES) {
            if(MIAOJU_ONSHOW_VALUES.scene == "021036" && MIAOJU_ONSHOW_VALUES.launch_from=="homepage" && MIAOJU_ONSHOW_VALUES.location=="sidebar_card"){
               //从侧边栏来：scene值为021036，launch_from为homepage，location为sidebar_card
               ssEventName = 'mj_sidebar_enter';
            }else if(MIAOJU_ONSHOW_VALUES.scene == "021020"){
                //来自桌面
                ssEventName = 'mj_desk_enter';
            }
        }
    }else if(funcType == 1){
        let options = getOptions(1);
        consolePrintWithTime('checkUserFrom 2:', options);
        if(options.scene == "021036"){
            //侧边栏
            ssEventName = 'mj_sidebar_enter';
        }else if(options.scene == "021020"){
            //来自桌面
            ssEventName = 'mj_desk_enter';
        }
    }

    if(ssEventName!=''){
        consolePrintWithTime('checkUserFrom ssReport:', ssEventName);
        ssReport({
            eventName: ssEventName
        })
    }
    
}

function buttonOne(params, callback) {
    if (!isInited()) {
        callback({
            "code": RETURN_CODE_NOT_INITED,
            "message": 'buttonOne未完成初始化',
            "data": {}
        });
        return;
    }
    consolePrintWithTime("buttonOne reciveparam", params);
    consolePrintWithTime("buttonOne callback", callback);

    tt.navigateToScene({
        scene: "sidebar",
        success: (res) => {
            consolePrintWithTime("navigate to scene success");
            // 跳转成功回调逻辑
        },
        fail: (res) => {
            consolePrintWithTime("navigate to scene fail: ", res);
            // 跳转失败回调逻辑
        },
    });
    
    callback({
        code: RETURN_CODE_SUCCESS,
        message: "buttonOne成功",
        data: {
            "clint_id": "xertertertertertert111",
            "isme": "yes",
            "newadd": 1
        }
    });
}

function buttonTwo(params, callback) {
    if (!isInited()) {
        callback({
            "code": RETURN_CODE_NOT_INITED,
            "message": 'buttonTwo未完成初始化',
            "data": {}
        });
        return;
    }
    consolePrintWithTime("buttonTwo reciveparam", params);
    consolePrintWithTime("buttonTwo callback", callback);



    callback({
        code: RETURN_CODE_SUCCESS,
        message: "buttonTwo成功",
        data: {
            "clint_id": "xertertertertertert",
            "isme": "yes",
            "newadd": 1
        }
    });
}

/**
 * 判断是否初始化
 */
function isInited() {
    return MIAOJU_IS_INITED
}

/**
 * 获得数数登录账号id
 */
function getAccountID(params) {
    return params.serverId + '_' + params.roleId
}

/**
 * 获取当前时间字符串
 * @param {} args 
 */
function getTime() {
    const date = new Date(); // 获取当前时间的 Date 对象

    const year = date.getFullYear();
    const month = String(date.getMonth() + 1).padStart(2, '0'); // 月份从0开始，需要+1，然后补零
    const day = String(date.getDate()).padStart(2, '0');
    const hours = String(date.getHours()).padStart(2, '0');
    const minutes = String(date.getMinutes()).padStart(2, '0');
    const seconds = String(date.getSeconds()).padStart(2, '0');

    const formattedDateTime = `${year}-${month}-${day} ${hours}:${minutes}:${seconds}`;
    return formattedDateTime
}

/**
 * wx.request请求接口
 * @param {*} args 
 */
function apiRequest(args = {}) {
    const user_info = tt.getStorageSync(CACHE_USER_INFO)
    const role_info = tt.getStorageSync(CACHE_ROLE_INFO)

    const options = getOptions(0)
    args.url = args.url
    args.data = args.data || {}
    // 公共参数
    args.data.platform_id = MIAOJU_PLATFORM_ID
    args.data.game_id = MIAOJU_GAME_ID
    args.data.client_id = getClientId()
    if (!args.data.token) {
      if(args.url.includes("user/login") && args.data.code){
        //如果是登录请求且参数里包含code，则不带token
      }else{
        args.data.token = user_info.token || ''
      }      
    }
    // 如果存在role_info 的缓存，则带上
    if (!args.data.role_info && role_info) {
        args.data.role_info = JSON.stringify(role_info) || ''
    }
    if (Object.keys(options.query).length !== 0) {
        // 说明query有值
        args.data.query = JSON.stringify(options.query)
        args.data.channel_id = options.query.channel_id || ''
    }
    args.data.device_info = JSON.stringify(MIAOJU_DEVICEINFO)
    consolePrintWithTime("请求链接:", args.url, args.data);

    return new Promise((resolve, reject) => {
        tt.request({
            fail: function (err) {
                consolePrintWithTime("tt.request 请求接口出错：", err);
                reject(err)
            },
            success: function (res) {
                // 对请求接口统一处理
                if (res.statusCode == 200) {
                    const code = res.data.code
                    switch (code) {
                        default:
                            resolve(res.data)
                            break;
                    }
                }
            },
            ...args,
        })
    })
}

/**
 * wx异步方法封装
 * @param {*} api 
 */
function wxPromisify(api) {
    return (args = {}) => {
        return new Promise((resolve, reject) => {
            api({
                fail: function (err) {
                    consolePrintWithTime("wx调用错误：", err);
                    reject(err)
                },
                success: function (res) {
                    consolePrintWithTime("wx调用成功：", res);
                    resolve(res)
                },
                ...args,
            })
        })
    }
}

/**
 * 获取启动参数
 * @isCache 1取全局变量，0取系统函数
 */
function getOptions(isCache = 0) {
    let options = {};
    if (isCache == 1) {
        options = MIAOJU_LAUNCHOPTIONS;
        //consolePrintWithTime("getOptions if", options);
    } else {
        options = tt.getLaunchOptionsSync();
        //consolePrintWithTime("getOptions else", options);
        MIAOJU_LAUNCHOPTIONS = options;
    }
    return options;
}

/**
 * 获取客户端id
 */
function getClientId() {
    var clientId = ''
    try {
        var value = tt.getStorageSync(CACHE_CLIENT_ID)
        if (value) {
            clientId = value;
        }
    } catch (e) {}

    if (clientId == '') {
        let obj = new GUID();
        clientId = obj.newGUID(MIAOJU_GAME_ID+'-2');
        try {
            tt.setStorageSync(CACHE_CLIENT_ID, clientId)
        } catch (e) {}
    }

    return clientId;

}

//生成guid
function GUID() {
    this.date = new Date();

    /* 判断是否初始化过，如果初始化过以下代码，则以下代码将不再执行，实际中只执行一次 */
    if (typeof this.newGUID != 'function') {

        /* 生成GUID码 */
        GUID.prototype.newGUID = function (str = "") {
            this.date = new Date();
            var guidStr = '';
            var sexadecimalDate = this.hexadecimal(this.getGUIDDate(), 16);
            var sexadecimalTime = this.hexadecimal(this.getGUIDTime(), 16);
            for (var i = 0; i < 9; i++) {
                guidStr += Math.floor(Math.random() * 16).toString(16);
            }
            guidStr += sexadecimalDate;
            guidStr += sexadecimalTime;
            while (guidStr.length < 32) {
                guidStr += Math.floor(Math.random() * 16).toString(16);
            }

            var strGuid = str + '-' + this.formatGUID(guidStr)
            return strGuid;
        }

        /*
         * 功能：获取当前日期的GUID格式，即8位数的日期：19700101
         * 返回值：返回GUID日期格式的字条串
         */
        GUID.prototype.getGUIDDate = function () {
            return this.date.getFullYear() + this.addZero(this.date.getMonth() + 1) + this.addZero(this.date.getDay());
        }

        /*
         * 功能：获取当前时间的GUID格式，即8位数的时间，包括毫秒，毫秒为2位数：12300933
         * 返回值：返回GUID日期格式的字条串
         */
        GUID.prototype.getGUIDTime = function () {
            return this.addZero(this.date.getHours()) + this.addZero(this.date.getMinutes()) + this.addZero(this.date.getSeconds()) + this.addZero(parseInt(this.date.getMilliseconds() / 10));
        }

        /*
         * 功能: 为一位数的正整数前面添加0，如果是可以转成非NaN数字的字符串也可以实现
         * 参数: 参数表示准备再前面添加0的数字或可以转换成数字的字符串
         * 返回值: 如果符合条件，返回添加0后的字条串类型，否则返回自身的字符串
         */
        GUID.prototype.addZero = function (num) {
            if (Number(num).toString() != 'NaN' && num >= 0 && num < 10) {
                return '0' + Math.floor(num);
            } else {
                return num.toString();
            }
        }

        /*
         * 功能：将y进制的数值，转换为x进制的数值
         * 参数：第1个参数表示欲转换的数值；第2个参数表示欲转换的进制；第3个参数可选，表示当前的进制数，如不写则为10
         * 返回值：返回转换后的字符串
         */
        GUID.prototype.hexadecimal = function (num, x, y) {
            if (y != undefined) {
                return parseInt(num.toString(), y).toString(x);
            } else {
                return parseInt(num.toString()).toString(x);
            }
        }

        /*
         * 功能：格式化32位的字符串为GUID模式的字符串
         * 参数：第1个参数表示32位的字符串
         * 返回值：标准GUID格式的字符串
         */
        GUID.prototype.formatGUID = function (guidStr) {
            var str1 = guidStr.slice(0, 8) + '-',
                str2 = guidStr.slice(8, 16) + '-',
                str3 = guidStr.slice(16, 24) + '-',
                str4 = guidStr.slice(24);
            return str1 + str2 + str3 + str4;
        }
    }
}


/**
 * 输出日志带日期时间
 */
function consolePrintWithTime(...msgs) {
    const now = new Date();
    const formattedDate = `${now.getFullYear()}-${(now.getMonth() + 1).toString().padStart(2, '0')}-${now.getDate().toString().padStart(2, '0')} ${now.getHours().toString().padStart(2, '0')}:${now.getMinutes().toString().padStart(2, '0')}:${now.getSeconds().toString().padStart(2, '0')}.${now.getMilliseconds().toString().padStart(3, '0')}`;
    console.log("[", formattedDate, "] MJSDK-DY:", ...msgs);
}
/**
 * 成功返回值
 */
function getSuccessReturn(data) {
    consolePrintWithTime("getSuccessReturn:", data);
    return {
        code: RETURN_CODE_SUCCESS,
        message: "",
        data: data
    }
}
/**
 * 返回值
 */
function getReturn(code, message, data) {
    consolePrintWithTime("getReturn:", code, message, data);
    return {
        code: code,
        message: message,
        data: data
    }
}

const MiaojuSdk = {
    init: init,
    pay: pay,
    rewardVideoAdCreate: rewardVideoAdCreate,
    rewardVideoAdCreate2: rewardVideoAdCreate,
    openCustomerService: openCustomerService,
    getUserInfo: getUserInfo,
    createRole: createRole,
    loginRole: loginRole,
    changeRole: changeRole,
    ssReport: ssReport,
    ssUserSet: ssUserSet,
    ylyqReport: ylyqReport,
    getUserLaunchInfo: getUserLaunchInfo,
    onMiniGameShow: onMiniGameShow,
    isFromSidebar: isFromSidebar,
    navigateToScene: navigateToScene,
    onKeyboardAction: onKeyboardAction,
    addShortcut: addShortcut,
    buttonOne: buttonOne,
    buttonTwo: buttonTwo
};

globalThis.MiaojuSdk = MiaojuSdk;